pro color_scale,r,g,b,igraph,ndiv,nplant,inoveg,ibw

; =========== DEFINING COLOR SCALE ===================================

  tvlct,r,g,b,/get
 
if (igraph eq -1) or (igraph eq -5) then begin

 if igraph eq -1 then begin   ;(dominant pft)
 
  r(1) = 240      
  g(1) = 240     
  b(1) = 255                  ;snow

  r(2) = 255      ; 150
  g(2) = 255      ; 150       ;no vegetation
  b(2) = 0        ; 150
  
  r(3) = 200       ;150       ;vert clair
  g(3) = 165       ;255
  b(3) = 30         ;0
  
  r(4) = 255       ;170      ;brun
  g(4) = 145       ;80
  b(4) = 0         ;0
  
  r(5) = 0       ;170      ;brun
  g(5) = 100        ;80
  b(5) = 70         ;0  
  
  
  r(6) = 10       
  g(6) = 140      ;160
  b(6) = 130       ;160

  r(7) = 20       
  g(7) = 190      ;195
  b(7) = 190       ;220  
    
  r(8) = 220
  g(8) = 160       ;0
  b(8) = 120
  
  
  r(9) = 150       ;0
  g(9) = 100    ;255
  b(9) = 210     ;90
  
  r(10) = 240
  g(10) = 100
  b(10) = 150
  
  r(11) = 190
  g(11) = 255
  b(11) = 100 
  
  r(12) = 245
  g(12) = 10         ;140
  b(12) = 40
    
  r(13) = 10        ;255
  g(13) = 165        ;255
  b(13) = 10
  
  r(14) = 20        ;255
  g(14) = 220        ;255
  b(14) = 25  
  
  r(15) = 140
  g(15) = 225
  b(15) =   0
  
  r(16) = 215     ;160
  g(16) = 110     ;100
  b(16) = 80  
  
  r(17) = 150    ;0  ;160
  g(17) = 50   ;60  ;100
  b(17) = 20    ;90   ;200
  
  r(18) = 150
  g(18) =  50
  b(18) =  20
  
  r(19) = 215
  g(19) = 110
  b(19) =  80  
    
  
 endif else begin
 ;  igraph = -5  (biomes)
 
  r(1) = 230
  g(1) = 230
  b(1) = 255

  r(2) = 255
  g(2) = 255
  b(2) = 70  

  r(3) = 245    ;205  ;225
  g(3) = 215    ;205  ;225
  b(3) = 35     ;20   ;35

  r(4) = 245
  g(4) = 170
  b(4) = 255

  r(5) = 255   ;255  ;210
  g(5) = 145   ;130  ;140
  b(5) = 0     ;  0  ;0
  
  r(6) = 200     ;255
  g(6) = 165     ;190
  b(6) = 30      ;0  

  r(7) = 247  ;235    ;247      
  g(7) = 171  ;171    ;180      
  b(7) =  85  ; 85    ; 90
  
  r(8) = 195  ;215   ;200   ;201 
  g(8) = 218  ;225   ;190   ;225
  b(8) = 76    ;80  ;85     ;78  
  
  r(9) = 100   ;130  ;215   ;143   ;136  
  g(9) = 160   ;145  ;225   ;160   ;152
  b(9) =  30    ;48   ;80    ;53    ;50
  
  r(10) = 150       
  g(10) = 50       
  b(10) = 20        

  r(11) = 215        
  g(11) = 110          
  b(11) = 80           

  r(12) =  255   ;255     ;230     ;217 ;215
  g(12) =   70 ;140     ;180     ;207 ;160
  b(12) =   70 ;140      ;90      ;90  ;80
  
  r(13) = 190    ;220
  g(13) = 255    ;255
  b(13) = 100    ;100
  
  r(14) = 20 ;0
  g(14) = 190 ;170
  b(14) = 190 ;160  
    
  r(15) = 150
  g(15) = 255
  b(15) = 210 
  
  r(16) = 0
  g(16) = 255
  b(16) = 90

  r(17) = 43
  g(17) = 130
  b(17) = 61      

  r(18) = 17  ;21
  g(18) = 210 ;192
  b(18) = 80  ;75

  r(19) = 140 ;160    ;160
  g(19) = 150 ;170    ;132
  b(19) = 175 ;198    ;198
  

 endelse
  
  
endif else begin

if (igraph eq -17) or (igraph le -21) then begin

if (igraph eq -21) then begin
;elevation

  kc = 0

  kc=kc+1  
  r(kc) = 0
  g(kc) = 0
  b(kc) = 100
  
  kc=kc+1  
  r(kc) = 0
  g(kc) = 0
  b(kc) = 210
  
  kc=kc+1  
  r(kc) = 0
  g(kc) = 150
  b(kc) = 210  

  kc=kc+1  
  r(kc) = 0
  g(kc) = 80
  b(kc) = 80
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 120
  b(kc) = 80
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 170
  b(kc) = 50
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 210
  b(kc) = 20
    
  kc=kc+1    
  r(kc) = 0
  g(kc) = 255
  b(kc) = 0
  
  kc=kc+1
  r(kc) =  70
  g(kc) = 255
  b(kc) = 0  

  kc=kc+1  
  r(kc) = 135
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 200
  g(kc) = 255
  b(kc) = 0  

  kc=kc+1  
  r(kc) = 255
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 220
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 150
  b(kc) = 0

  kc=kc+1  
  r(kc) = 210
  g(kc) = 120
  b(kc) = 0

  kc=kc+1  
  r(kc) = 160
  g(kc) = 94
  b(kc) = 0

  kc=kc+1  
  r(kc) = 130
  g(kc) = 75
  b(kc) = 0

  kc=kc+1  
  r(kc) = 90
  g(kc) = 50
  b(kc) = 0  

  kc=kc+1      
  r(kc) = 50
  g(kc) = 10
  b(kc) = 0 

  kc=kc+1     
  r(kc) = 255
  g(kc) = 240
  b(kc) = 240  
  
endif else begin

  kc = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 0
  b(kc) = 255
  
  kc=kc+1  
  r(kc) = 200
  g(kc) = 0
  b(kc) = 255
  
  kc=kc+1  
  r(kc) = 150
  g(kc) = 0
  b(kc) = 255  

  kc=kc+1  
  r(kc) = 100
  g(kc) = 0
  b(kc) = 255
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 0
  b(kc) = 255
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 100
  b(kc) = 255
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 170
  b(kc) = 255
    
  kc=kc+1    
  r(kc) = 0
  g(kc) = 255
  b(kc) = 255
  
  kc=kc+1
  r(kc) = 0
  g(kc) = 255
  b(kc) = 170  

  kc=kc+1  
  r(kc) = 0
  g(kc) = 255
  b(kc) = 90

  kc=kc+1  
  r(kc) = 0
  g(kc) = 255
  b(kc) = 0  

  kc=kc+1  
  r(kc) = 80
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 140
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 200
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 255
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 200
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 150
  b(kc) = 0
  
  kc=kc+1  
  r(kc) = 255
  g(kc) = 105
  b(kc) = 0  

  kc=kc+1  
  r(kc) = 255
  g(kc) = 60
  b(kc) = 0

  kc=kc+1  
  r(kc) = 255
  g(kc) = 0
  b(kc) = 0  

  kc=kc+1      
  r(kc) = 190
  g(kc) = 0
  b(kc) = 0 

  kc=kc+1     
  r(kc) = 130
  g(kc) = 0
  b(kc) = 0
  
  kc=kc+1     
  r(kc) = 70
  g(kc) = 0
  b(kc) = 0  

endelse

endif else begin

if (igraph ge 5*nplant+1) and (igraph le 6*nplant) then begin

  kc = 0
 
  kc=kc+1  
  r(kc) = 210
  g(kc) = 120
  b(kc) = 0
  
  kc=kc+1  
  r(kc) = 90
  g(kc) = 230
  b(kc) = 20
  
endif else begin

if ibw eq 1 then begin

  colmax = 255
  colmin = 60

  for kc = 1, ndiv+2 do begin
    jcol = fix(colmin+(colmax-colmin)*(ndiv+2-kc)/(ndiv+1)+0.0001)  
    r(kc) = jcol
    g(kc) = jcol
    b(kc) = jcol
  endfor
  
endif else begin
 
 if inoveg eq 0 then begin

  r(1) = 200
  g(1) = 200
  b(1) = 200
  
  r(2) = 220
  g(2) = 0
  b(2) = 255
  
  r(3) = 130
  g(3) = 0
  b(3) = 255  

 endif else begin  
 ;if (igraph le -2) or ((igraph ge 2*nplant+1) and (igraph le 3*nplant)) then begin 
 
  r(1) = 100
  g(1) = 100
  b(1) = 100
  
  r(2) = 200
  g(2) = 200
  b(2) = 200
  
  r(3) = 130
  g(3) = 0
  b(3) = 255 
   
 endelse

  r(4) = 0
  g(4) = 0
  b(4) = 255
         
  r(5) = 0
  g(5) = 180
  b(5) = 255
  
  r(6) = 0
  g(6) = 255
  b(6) = 255

  r(7) = 0
  g(7) = 255
  b(7) = 170  
    
  r(8) = 0
  g(8) = 255
  b(8) = 0
  
  r(9) = 150
  g(9) = 255
  b(9) = 0
  
  r(10) = 255
  g(10) = 255
  b(10) = 0
  
  r(11) = 255
  g(11) = 200
  b(11) = 0  
  
  r(12) = 255
  g(12) = 150
  b(12) = 0    
  
  r(13) = 255
  g(13) = 100
  b(13) = 0
  
  r(14) = 255
  g(14) = 50
  b(14) = 0  
  
  r(15) = 255
  g(15) = 0
  b(15) = 0
  
  r(16) = 180
  g(16) = 0
  b(16) = 0
  
  r(17) = 100
  g(17) = 0
  b(17) = 0
  
  r(18) = 50
  g(18) = 0
  b(18) = 0
  
  endelse  
 endelse 
endelse  
endelse  

  r(200) = 0
  g(200) = 0
  b(200) = 0

  tvlct,r,g,b

return
end
